/*******************************************************************************

Copyright(c) 2022-2023 Analog Devices, Inc. All Rights Reserved.

This software is proprietary.  By using this software you
agree to the terms of the associated Analog Devices License Agreement.

*******************************************************************************/

/** @defgroup FIR_Driver Finite Impulse Response (FIR) Accelerator Driver
 *  @{
 */
/*!
* @file      adi_fir.h
*
* @brief     FIR Accelerator Driver header file.
*
* @details
*            This is the primary header file for the FIR Accelerator.
*/

#ifndef __ADI_FIR_H__
#define __ADI_FIR_H__

#ifdef __cplusplus 
extern "C" { 
#endif /* __cplusplus */

#if defined(__ADSPSC835_FAMILY__)
#if defined(__ADSPSHARCFX__)
#include "adi_fir_v3.h"
#else
#error "This core is not supported"
#endif
#endif /* defined(__ADSPSC835_FAMILY__) */

#ifdef __cplusplus 
} 
#endif /* __cplusplus */

#endif /* __ADI_FIR_H__ */
/*@}*/
