/** @addtogroup FIR_Driver
 *  @{
 */

/*! *****************************************************************************
 * @file    adi_fir_v3.h
 * @brief   FIR Device driver definitions and APIs for ADSP-SC83x processors
 * @details Header File for the FIR driver API functions and definitions for ADSP-SC83x processors
 * @version $Revision:
 * @date:    $Date:
 *****************************************************************************

Copyright(c) 2022-2023 Analog Devices, Inc. All Rights Reserved.
This software is proprietary.  By using this software you agree
to the terms of the associated Analog Devices License Agreement.

*********************************************************************************/

#ifndef __ADI_FIR_V3_H__
#define __ADI_FIR_V3_H__

#include <sys/platform.h>
#include <services/int/adi_int.h>

#include <drivers/fir/adi_fir_config_SC8xx.h>

#if ((ADI_FIR_CFG_ACCELERATOR_MODE == ADI_FIR_ACCELERATOR_MODE_LEGACY))

/* FIR Driver implementation source for legacy mode */
#include "adi_fir_legacy_v3.h"

#elif ((ADI_FIR_CFG_ACCELERATOR_MODE == ADI_FIR_ACCELERATOR_MODE_ACM))

/* FIR Driver implementation source for legacy mode */
#include "adi_fir_acm_v3.h"

#else

#error "Selected Configuration/Processor not Supported"

#endif

#endif /* __ADI_FIR_V3_H__ */

/*@}*/







