/*******************************************************************************

Copyright(c) 2022-2023 Analog Devices, Inc. All Rights Reserved.

This software is proprietary.  By using this software you
agree to the terms of the associated Analog Devices License Agreement.

*******************************************************************************/

/** @defgroup IIR_Driver Infinite Impulse Response (IIR) Accelerator Driver
 *  @{
 */
/*!
* @file      adi_iir.h
*
* @brief     IIR Accelerator Driver header file.
*
* @details
*            This is the primary header file for the IIR Accelerator.
*/

#ifndef __ADI_IIR_H__
#define __ADI_IIR_H__

#ifdef __cplusplus 
extern "C" { 
#endif /* __cplusplus */

#if defined(__ADSPSC835_FAMILY__)
#if defined(__ADSPSHARCFX__)
#include "adi_iir_v3.h"
#else
#error "This core is not supported"
#endif
#endif /* defined(__ADSPSC835_FAMILY__) */

#ifdef __cplusplus 
} 
#endif /* __cplusplus */

#endif /* __ADI_IIR_H__ */
/*@}*/
