/*! *****************************************************************************
 * @file    adi_iir_v3.h
 * @brief   IIR Device driver definitions and APIs
 * @details Header File for the IIR driver API functions and definitions for ADSP-SC83x processors
 * @version $Revision:
 * @date:    $Date:
 *****************************************************************************

Copyright(c) 2022-2023 Analog Devices, Inc. All Rights Reserved.
This software is proprietary.  By using this software you agree
to the terms of the associated Analog Devices License Agreement.

*********************************************************************************/

/** @addtogroup IIR_Driver
 *  @{
 */

#ifndef __ADI_IIR_V3_H__
#define __ADI_IIR_V3_H__

#include <sys/platform.h>
#include <services/int/adi_int.h>
#include <drivers/iir/adi_iir_config_SC8xx.h>

#if ((ADI_IIR_CFG_ACCELERATOR_MODE == ADI_IIR_ACCELERATOR_MODE_LEGACY))

/* IIR Driver implementation source for legacy mode */
#include "adi_iir_legacy_v3.h"

#elif ((ADI_IIR_CFG_ACCELERATOR_MODE == ADI_IIR_ACCELERATOR_MODE_ACM))

/* IIR Driver implementation source for acm mode */
#include "adi_iir_acm_v3.h"

#else

#error "Selected Configuration/Processor not Supported"

#endif

#endif /* __ADI_IIR_V3_H__ */

/*@}*/







