/*********************************************************************************
Copyright(c) 2021 Analog Devices, Inc. All Rights Reserved.
This software is proprietary and confidential. By using this software you agree
to the terms of the associated Analog Devices License Agreement.
*********************************************************************************/

/*****************************************************************************
 * Audio_Talkthrough_I2S.h
 *****************************************************************************/

#ifndef __AUDIO_TALKTHROUGH_I2S_H__
#define __AUDIO_TALKTHROUGH_I2S_H__

#define USE_FPLL

/* 22.5792/512 = 44.1KHz, 22.5796/8 = 2.8224 MHz */
#define PCG_CLKDIV			8
#define PCG_FSDIV			512

/* Add your custom header content here */
#define ADD_ASRC

#define SPORT_CLK_DIV 	43 /* 125/44 = 2.841 MHz BCLK, 44.4 KHz LRCLK */
#define SPORT_FS_DIV 	31 /* 125/44 = 2.841 MHz BCLK, 44.4 KHz LRCLK */

#include <stdint.h>

/* Enable this macro for continuous audio */
#define ADI_CONFIG_CONTINUOUS_AUDIO		1


#define DECODE_SIZE					2048
#define SPORT_BUFF_SIZE 			BLOCK_SIZE*2//256

#define SPORT_DEVICE_4A 			4u			/* SPORT device number */
#define SPORT_DEVICE_4B 			4u			/* SPORT device number */
#define TWIDEVNUM     				2u         /* TWI device number */

#define BITRATE       				(100u)      /* kHz */
#define DUTYCYCLE     				(50u)       /* percent */
#define PRESCALEVALUE 				(12u)       /* fSCLK/10MHz (112.5 sclk0_0) */
#define BUFFER_SIZE   				(8u)

#define TARGETADDR    				(0x38u)     /* hardware address */
#define TARGETADDR_1962    			(0x04u)     /* hardware address of adau1962 DAC */
#define TARGETADDR_1979    			(0x11u)     /* hardware address of adau1979 ADC */


#define SPORT_4A_SPU  					66
#define SPORT_4B_SPU   					67
#define UART0_TxDMA_SPU_PID       	(74)
#define UART0_RxDMA_SPU_PID       	(75)

#define DMA_NUM_DESC 				2u

#define SUCCESS   0
#define FAILED   -1

#define CHECK_RESULT(eResult) \
        if(eResult != 0)\
		{\
			return (1);\
        }

#define REPORT_ERROR        	 printf
#define DEBUG_INFORMATION        printf

extern void OggVorbisInit();

#endif /* __AUDIO_TALKTHROUGH_I2S_H__ */
